--Copitor
--Mathieu Jacquin
--https://gumroad.com/l/Copitor
--http://www.mathieujacquin.com/
-----=====================================================================================================================
--04/10/2017 v3
--Added Option button for toggle merge material from Copitor
--Fixed some issues when running copitor for the first time

--04/08/2017 v2.5
--Slot6 ONLY can have a special folder to use it on lan network with NAS

--03/07/2017 v2.3
--tested on Max 2018, all seem to be ok

--08/05/2017 v2.2
--fix the undo state hidding grid and wire no more!
--thumbnail ratio change
--add 1 more slot

--28/11/2016 v2.1
--Position of Copitor is now saved. If you want reset the position of copitor, go in your autoback folder, and open "copytor.ini" then delete 2 lines of [DialogPosition]
--Fix Thumbnails size
--Fix the undo state always hidding grid and wire

--05/05/2016 v2
--Better ui for 3dsmax 2014 and newer
--add 5e slots
--Fix some crash

--07/03/2011 v1.61
--Added on Scriptspot  http://www.scriptspot.com/3ds-max/scripts/copitor
--Fix some crash

--16/11/2010 v1.5
--Add a 4e slot

--02/11/2010 v1.4
--Fix some crash

--30/10/2010 v1.3
--Fix some crash

--29/10/2010 v1.0 !
--Launch !


macroScript Copitor category:"zOffTy Tools" tooltip:" Copitor " buttonText: "Copitor"(
-----=====================================================================================================================
	Global	width = 800 --150
	Global	height = 800 --152
	Global   NetworkSlot = (getDir #AutoBack )
	--Global	MatOverrideStatus
	
	MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
	nombredobjetselectionnay1 = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste1" "nombredobjetselectionnay1"
	nombredobjetselectionnay2 = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste2" "nombredobjetselectionnay2"
	nombredobjetselectionnay3 = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste3" "nombredobjetselectionnay3"
	nombredobjetselectionnay4 = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste4" "nombredobjetselectionnay4"
	nombredobjetselectionnay5 = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste5" "nombredobjetselectionnay5"
	nombredobjetselectionnay6 = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste6" "nombredobjetselectionnay6"
	NetworkSlot = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste6Slot" "NetworkSlot"
	try (DialogPositionz = GetINISetting((getDir #AutoBack )+"\\copytor.ini") "DialogPosition" "dialogPos") catch()
--	boulu = "nop"
--	print (NetworkSlot as string +"start")
-----=====================================================================================================================
	try(closeRolloutfloater Copitor) catch()
--	clearListener()
	try(	
	if MatOverrideStatus == "" then (
		SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus" (false as string)
		) 
	else ()
		)
		catch()
	
rollout Copitor "Copitor v3" width:130 height:865  --pos:[30,30]
(
-----=====================================================================================================================
on Copitor close do (
SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "DialogPosition" "dialogPos" ((getdialogpos Copitor) as string)
) 


	
button btnCopitorOptions "> Copitor Options <" width:110 height:20 toolTip:"Options for Copitor"
on btnCopitorOptions pressed do
(
MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
print MatOverrideStatus as string
rollout CopitOptions "Copitor Options"
	(
	checkbox ckbtnMatOverride " Use Scene Materials when merging (if unchecked, a popup will ask you)" pos:[15,20] width:380 height:25 checked:(MatOverrideStatus as booleanClass)
	checkbox ckbtnMoreToCome " More options later" pos:[15,50]
	button CopitOptionsCancel "Cancel" pos:[260,80] width:50 height:28
	button CopitOptionsApply "Apply" pos:[320,80] width:70 height:28
		
		on CopitOptionsApply pressed do
			(
				print ckbtnMatOverride.state
				SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus" (ckbtnMatOverride.state as string)
				destroyDialog CopitOptions
			)
		on CopitOptionsCancel pressed do 	destroyDialog CopitOptions
	)
createdialog CopitOptions 400 115
)	

-----=====================================================================================================================

group  "Copy/Paste_1"
	(
	button Copyselected1 "Copy 1" width:110 height:20 toolTip:"Copy selectioned objects in Autoback folder"
	button Pasteselected1 "Empty Slot" width:110 height:80 toolTip:(nombredobjetselectionnay1 + " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder")
		
on Copyselected1 pressed do
	(
	if selection.count != 0 then (
		saveNodes $ (getdir #AutoBack + "\\CopyPaste1.max") 
 		undo on 
			(
				max hide inv -- Hide unselected objects to have a nice portrait
				boulu = "nop"
				if viewport.numViews!=1 then (max tool maximize) else (boulu = "yep") --- Maximise viewport IF it's not already maximised 
			)
				
				isViewportgridvisible = viewport.getGridVisibility(1) -- Get Grid state
				isWirevisible = viewport.GetShowEdgeFaces()  -- Get Wire state
				Pasteselected1.tooltip = (selection.count as string)+ " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder"
				clearSelection()
				viewport.SetShowEdgeFaces off -- Hide Wire for the screenshot
				viewport.setGridVisibility 1 off -- Hide Grid for the screenshot
			
		local grab_tempbmp1 --bitmap to put the Raw snapshot into
		local grab_bmp1 --bitmap to put the Modified snapshot into
		grab_width = gw.getWinSizeX()
		grab_Height = gw.getWinSizeY()
		gw.setPos 0 0 Width Height
		SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste1" "nombredobjetselectionnay1" (selection.count as string)
		completeredraw()
		grab_tempbmp1 = gw.getViewportDib() --Get the viewport bitmap into variable
		grab_bmp1 = bitmap 106 76 color:white -- Size of the thumbnails
		copy grab_tempbmp1 grab_bmp1 -- Transform Raw Snapshot
		theway = (getDir #AutoBack )+"\\CopyPaste1.bmp"
		grab_bmp1.filename = theway --set output name to the one entered in the save file dialog
		save grab_bmp1 -- Save the bitmap
		gw.setPos 0 0 grab_width grab_height
		Pasteselected1.images = #(grab_bmp1, undefined, 1,1,1,1,1 )
		viewport.setGridVisibility 1 (isViewportgridvisible) --Re Set the Gride state
		viewport.SetShowEdgeFaces(isWirevisible) -- Re Set the Wire state
		max undo -- Unhide Objects to get the same state from start


	PastBMP1 =(getDir #AutoBack )+"\\CopyPaste1.bmp"
	Pasteselected1.images = #(PastBMP1, undefined, 1,1,1,1,1 ) 
		if boulu == "nop"  then (max tool maximize) else()
		completeredraw()
		)
	else (print "Select Anything to Save !")
)
on Pasteselected1 pressed do
	(
		if keyboard.controlPressed then
			(
			shellLaunch "explorer.exe" (getdir #AutoBack)
			)
		else
			(
				MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
				if MatOverrideStatus == "true" then 
				(
					print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste1.max") #useSceneMtlDups #select #mergeDups)
				else
				(print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste1.max") #select #mergeDups)	
			)
	)
on CopyPaste1 open do try (
		PastBMP1 =(getDir #AutoBack )+"\\CopyPaste1.bmp"
		Pasteselected1.images = #(PastBMP1, undefined, 1,1,1,1,1 ) 
	) catch (print"Je suis un bouton vierge !")
)

-----=====================================================================================================================

group  "Copy/Paste_2"
	(
	button Copyselected2 "Copy 2" width:110 height:20 toolTip:"Copy selectioned objects in Autoback folder"
	button Pasteselected2 "Empty Slot" width:110 height:80 toolTip:(nombredobjetselectionnay2 + " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder")
		
on Copyselected2 pressed do
	(
	if selection.count != 0 then (
		saveNodes $ (getdir #AutoBack + "\\CopyPaste2.max") 
 		undo on 
			(
				max hide inv -- Hide unselected objects to have a nice portrait
				boulu = "nop"
				if viewport.numViews!=1 then (max tool maximize) else (boulu = "yep") --- Maximise viewport IF it's not already maximised 
			)
				
				isViewportgridvisible = viewport.getGridVisibility(1) -- Get Grid state
				isWirevisible = viewport.GetShowEdgeFaces()  -- Get Wire state
				Pasteselected2.tooltip = (selection.count as string)+ " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder"
				clearSelection()
				viewport.SetShowEdgeFaces off -- Hide Wire for the screenshot
				viewport.setGridVisibility 1 off -- Hide Grid for the screenshot
			
		local grab_tempbmp2 --bitmap to put the Raw snapshot into
		local grab_bmp2 --bitmap to put the Modified snapshot into
		grab_width = gw.getWinSizeX()
		grab_Height = gw.getWinSizeY()
		gw.setPos 0 0 Width Height
		SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste2" "nombredobjetselectionnay2" (selection.count as string)
		completeredraw()
		grab_tempbmp2 = gw.getViewportDib() --Get the viewport bitmap into variable
		grab_bmp2 = bitmap 106 76 color:white -- Size of the thumbnails
		copy grab_tempbmp2 grab_bmp2 -- Transform Raw Snapshot
		theway = (getDir #AutoBack )+"\\CopyPaste2.bmp"
		grab_bmp2.filename = theway --set output name to the one entered in the save file dialog
		save grab_bmp2 -- Save the bitmap
		gw.setPos 0 0 grab_width grab_height
		Pasteselected2.images = #(grab_bmp2, undefined, 1,1,1,1,1 )
		viewport.setGridVisibility 1 (isViewportgridvisible) --Re Set the Gride state
		viewport.SetShowEdgeFaces(isWirevisible) -- Re Set the Wire state
		max undo -- Unhide Objects to get the same state from start


	PastBMP2 =(getDir #AutoBack )+"\\CopyPaste2.bmp"
	Pasteselected2.images = #(PastBMP2, undefined, 1,1,1,1,1 ) 
		if boulu == "nop"  then (max tool maximize) else()
		completeredraw()
		)
	else (print "Select Anything to Save !")
)
on Pasteselected2 pressed do
	(
		if keyboard.controlPressed then
			(
			shellLaunch "explorer.exe" (getdir #AutoBack)
			)
		else
			(
				MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
				if MatOverrideStatus == "true" then 
				(
					print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste2.max") #useSceneMtlDups #select #mergeDups)
				else
				(print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste2.max") #select #mergeDups)	
			)
	)
on CopyPaste2 open do try (
		PastBMP2 =(getDir #AutoBack )+"\\CopyPaste2.bmp"
		Pasteselected2.images = #(PastBMP2, undefined, 1,1,1,1,1 ) 
	) catch (print"Je suis un bouton vierge !")
)


-----=====================================================================================================================

group  "Copy/Paste_3"
	(
	button Copyselected3 "Copy 3" width:110 height:20 toolTip:"Copy selectioned objects in Autoback folder"
	button Pasteselected3 "Empty Slot" width:110 height:80 toolTip:(nombredobjetselectionnay3 + " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder")
		
on Copyselected3 pressed do
	(
	if selection.count != 0 then (
		saveNodes $ (getdir #AutoBack + "\\CopyPaste3.max") 
 		undo on 
			(
				max hide inv -- Hide unselected objects to have a nice portrait
				boulu = "nop"
				if viewport.numViews!=1 then (max tool maximize) else (boulu = "yep") --- Maximise viewport IF it's not already maximised 
			)
				
				isViewportgridvisible = viewport.getGridVisibility(1) -- Get Grid state
				isWirevisible = viewport.GetShowEdgeFaces()  -- Get Wire state
				Pasteselected3.tooltip = (selection.count as string)+ " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder"
				clearSelection()
				viewport.SetShowEdgeFaces off -- Hide Wire for the screenshot
				viewport.setGridVisibility 1 off -- Hide Grid for the screenshot
			
		local grab_tempbmp3 --bitmap to put the Raw snapshot into
		local grab_bmp3 --bitmap to put the Modified snapshot into
		grab_width = gw.getWinSizeX()
		grab_Height = gw.getWinSizeY()
		gw.setPos 0 0 Width Height
		SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste3" "nombredobjetselectionnay3" (selection.count as string)
		completeredraw()
		grab_tempbmp3 = gw.getViewportDib() --Get the viewport bitmap into variable
		grab_bmp3 = bitmap 106 76 color:white -- Size of the thumbnails
		copy grab_tempbmp3 grab_bmp3 -- Transform Raw Snapshot
		theway = (getDir #AutoBack )+"\\CopyPaste3.bmp"
		grab_bmp3.filename = theway --set output name to the one entered in the save file dialog
		save grab_bmp3 -- Save the bitmap
		gw.setPos 0 0 grab_width grab_height
		Pasteselected3.images = #(grab_bmp3, undefined, 1,1,1,1,1 )
		viewport.setGridVisibility 1 (isViewportgridvisible) --Re Set the Gride state
		viewport.SetShowEdgeFaces(isWirevisible) -- Re Set the Wire state
		max undo -- Unhide Objects to get the same state from start


	PastBMP3 =(getDir #AutoBack )+"\\CopyPaste3.bmp"
	Pasteselected3.images = #(PastBMP3, undefined, 1,1,1,1,1 ) 
		if boulu == "nop"  then (max tool maximize) else()
		completeredraw()
		)
	else (print "Select Anything to Save !")
)
on Pasteselected3 pressed do
	(
		if keyboard.controlPressed then
			(
			shellLaunch "explorer.exe" (getdir #AutoBack)
			)
		else
			(
				MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
				if MatOverrideStatus == "true" then 
				(
					print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste3.max") #useSceneMtlDups #select #mergeDups)
				else
				(print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste3.max") #select #mergeDups)	
			)
	)
on CopyPaste3 open do try (
		PastBMP3 =(getDir #AutoBack )+"\\CopyPaste3.bmp"
		Pasteselected3.images = #(PastBMP3, undefined, 1,1,1,1,1 ) 
	) catch (print"Je suis un bouton vierge !")
)

-----=====================================================================================================================

group  "Copy/Paste_4"
	(
	button Copyselected4 "Copy 4" width:110 height:20 toolTip:"Copy selectioned objects in Autoback folder"
	button Pasteselected4 "Empty Slot" width:110 height:80 toolTip:(nombredobjetselectionnay4 + " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder")
		
on Copyselected4 pressed do
	(
	if selection.count != 0 then (
		saveNodes $ (getdir #AutoBack + "\\CopyPaste4.max") 
 		undo on 
			(
				max hide inv -- Hide unselected objects to have a nice portrait
				boulu = "nop"
				if viewport.numViews!=1 then (max tool maximize) else (boulu = "yep") --- Maximise viewport IF it's not already maximised 
			)
				
				isViewportgridvisible = viewport.getGridVisibility(1) -- Get Grid state
				isWirevisible = viewport.GetShowEdgeFaces()  -- Get Wire state
				Pasteselected4.tooltip = (selection.count as string)+ " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder"
				clearSelection()
				viewport.SetShowEdgeFaces off -- Hide Wire for the screenshot
				viewport.setGridVisibility 1 off -- Hide Grid for the screenshot
			
		local grab_tempbmp4 --bitmap to put the Raw snapshot into
		local grab_bmp4 --bitmap to put the Modified snapshot into
		grab_width = gw.getWinSizeX()
		grab_Height = gw.getWinSizeY()
		gw.setPos 0 0 Width Height
		SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste4" "nombredobjetselectionnay4" (selection.count as string)
		completeredraw()
		grab_tempbmp4 = gw.getViewportDib() --Get the viewport bitmap into variable
		grab_bmp4 = bitmap 106 76 color:white -- Size of the thumbnails
		copy grab_tempbmp4 grab_bmp4 -- Transform Raw Snapshot
		theway = (getDir #AutoBack )+"\\CopyPaste4.bmp"
		grab_bmp4.filename = theway --set output name to the one entered in the save file dialog
		save grab_bmp4 -- Save the bitmap
		gw.setPos 0 0 grab_width grab_height
		Pasteselected4.images = #(grab_bmp4, undefined, 1,1,1,1,1 )
		viewport.setGridVisibility 1 (isViewportgridvisible) --Re Set the Gride state
		viewport.SetShowEdgeFaces(isWirevisible) -- Re Set the Wire state
		max undo -- Unhide Objects to get the same state from start


	PastBMP4 =(getDir #AutoBack )+"\\CopyPaste4.bmp"
	Pasteselected4.images = #(PastBMP4, undefined, 1,1,1,1,1 ) 
		if boulu == "nop"  then (max tool maximize) else()
		completeredraw()
		)
	else (print "Select Anything to Save !")
)
on Pasteselected4 pressed do
	(
		if keyboard.controlPressed then
			(
			shellLaunch "explorer.exe" (getdir #AutoBack)
			)
		else
			(
				MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
				if MatOverrideStatus == "true" then 
				(
					print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste4.max") #useSceneMtlDups #select #mergeDups)
				else
				(print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste4.max") #select #mergeDups)	
			)
	)
on CopyPaste4 open do try (
		PastBMP4 =(getDir #AutoBack )+"\\CopyPaste4.bmp"
		Pasteselected4.images = #(PastBMP4, undefined, 1,1,1,1,1 ) 
	) catch (print"Je suis un bouton vierge !")
)


-----=====================================================================================================================

group  "Copy/Paste_5"
	(
	button Copyselected5 "Copy 5" width:110 height:20 toolTip:"Copy selectioned objects in Autoback folder"
	button Pasteselected5 "Empty Slot" width:110 height:80 toolTip:(nombredobjetselectionnay5 + " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder")
		
on Copyselected5 pressed do
	(
	if selection.count != 0 then (
		saveNodes $ (getdir #AutoBack + "\\CopyPaste5.max") 
 		undo on 
			(
				max hide inv -- Hide unselected objects to have a nice portrait
				boulu = "nop"
				if viewport.numViews!=1 then (max tool maximize) else (boulu = "yep") --- Maximise viewport IF it's not already maximised 
			)
				
				isViewportgridvisible = viewport.getGridVisibility(1) -- Get Grid state
				isWirevisible = viewport.GetShowEdgeFaces()  -- Get Wire state
				Pasteselected5.tooltip = (selection.count as string)+ " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder"
				clearSelection()
				viewport.SetShowEdgeFaces off -- Hide Wire for the screenshot
				viewport.setGridVisibility 1 off -- Hide Grid for the screenshot
			
		local grab_tempbmp5 --bitmap to put the Raw snapshot into
		local grab_bmp5 --bitmap to put the Modified snapshot into
		grab_width = gw.getWinSizeX()
		grab_Height = gw.getWinSizeY()
		gw.setPos 0 0 Width Height
		SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste5" "nombredobjetselectionnay5" (selection.count as string)
		completeredraw()
		grab_tempbmp5 = gw.getViewportDib() --Get the viewport bitmap into variable
		grab_bmp5 = bitmap 106 76 color:white -- Size of the thumbnails
		copy grab_tempbmp5 grab_bmp5 -- Transform Raw Snapshot
		theway = (getDir #AutoBack )+"\\CopyPaste5.bmp"
		grab_bmp5.filename = theway --set output name to the one entered in the save file dialog
		save grab_bmp5 -- Save the bitmap
		gw.setPos 0 0 grab_width grab_height
		Pasteselected5.images = #(grab_bmp5, undefined, 1,1,1,1,1 )
		viewport.setGridVisibility 1 (isViewportgridvisible) --Re Set the Gride state
		viewport.SetShowEdgeFaces(isWirevisible) -- Re Set the Wire state
		max undo -- Unhide Objects to get the same state from start


	PastBMP5 =(getDir #AutoBack )+"\\CopyPaste5.bmp"
	Pasteselected5.images = #(PastBMP5, undefined, 1,1,1,1,1 ) 
		if boulu == "nop"  then (max tool maximize) else()
		completeredraw()
		)
	else (print "Select Anything to Save !")
)
on Pasteselected5 pressed do
	(
		if keyboard.controlPressed then
			(
			shellLaunch "explorer.exe" (getdir #AutoBack)
			)
		else
			(
				MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
				if MatOverrideStatus == "true" then 
				(
					print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste5.max") #useSceneMtlDups #select #mergeDups)
				else
				(print MatOverrideStatus
				mergemaxfile (getdir #AutoBack + "\\CopyPaste5.max") #select #mergeDups)	
			)
	)
on CopyPaste5 open do try (
		PastBMP5 =(getDir #AutoBack )+"\\CopyPaste5.bmp"
		Pasteselected5.images = #(PastBMP5, undefined, 1,1,1,1,1 ) 
	) catch (print"Je suis un bouton vierge !")
)

-----=====================================================================================================================

group  "Copy/Paste_6"
	(
	button Copyselected6 "Copy 6" pos:[10,723] width:86 height:20 toolTip:"Copy selectioned objects in Selected folder"
	button ConfPath "[+]" pos:[97,723]width:22 height:20 toolTip:(NetworkSlot as string)
	button Pasteselected6 "Empty Slot" width:110 height:80 toolTip:(nombredobjetselectionnay6 + " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Selected folder")
		
on Copyselected6 pressed do
	(
	if selection.count != 0 then (
		saveNodes $ (NetworkSlot + "\\CopyPaste6.max") 
 		undo on 
			(
				max hide inv -- Hide unselected objects to have a nice portrait
				boulu = "nop"
				if viewport.numViews!=1 then (max tool maximize) else (boulu = "yep") --- Maximise viewport IF it's not already maximised 
			)
				
				isViewportgridvisible = viewport.getGridVisibility(1) -- Get Grid state
				isWirevisible = viewport.GetShowEdgeFaces()  -- Get Wire state
				Pasteselected6.tooltip = (selection.count as string)+ " Objects - " + " PASTE - Paste this package in the current max scene - Control+Click = open Autoback folder"
				clearSelection()
				viewport.SetShowEdgeFaces off -- Hide Wire for the screenshot
				viewport.setGridVisibility 1 off -- Hide Grid for the screenshot
			
		local grab_tempbmp6 --bitmap to put the Raw snapshot into
		local grab_bmp6 --bitmap to put the Modified snapshot into
		grab_width = gw.getWinSizeX()
		grab_Height = gw.getWinSizeY()
		gw.setPos 0 0 Width Height
		SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste6" "nombredobjetselectionnay6" (selection.count as string)
		completeredraw()
		grab_tempbmp6 = gw.getViewportDib() --Get the viewport bitmap into variable
		grab_bmp6 = bitmap 106 76 color:white -- Size of the thumbnails
		copy grab_tempbmp6 grab_bmp6 -- Transform Raw Snapshot
		theway = NetworkSlot +"\\CopyPaste6.bmp"
		grab_bmp6.filename = theway --set output name to the one entered in the save file dialog
		save grab_bmp6 -- Save the bitmap
		gw.setPos 0 0 grab_width grab_height
		Pasteselected6.images = #(grab_bmp6, undefined, 1,1,1,1,1 )
		viewport.setGridVisibility 1 (isViewportgridvisible) --Re Set the Gride state
		viewport.SetShowEdgeFaces(isWirevisible) -- Re Set the Wire state
		max undo -- Unhide Objects to get the same state from start


	PastBMP6 =NetworkSlot +"\\CopyPaste6.bmp"
	Pasteselected6.images = #(PastBMP6, undefined, 1,1,1,1,1 ) 
		if boulu == "nop"  then (max tool maximize) else()
		completeredraw()
		)
	else (print "Select Anything to Save !")
)
on Pasteselected6 pressed do
	(
		if keyboard.controlPressed then
			(
			shellLaunch "explorer.exe" NetworkSlot
			)
		else
			(
				MatOverrideStatus = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "MaterialOverride" "MaterialOverrideStatus"
				if MatOverrideStatus == "true" then 
				(
					print MatOverrideStatus
				mergemaxfile (NetworkSlot + "\\CopyPaste6.max") #useSceneMtlDups #select #mergeDups)
				else
				(print MatOverrideStatus
				mergemaxfile (NetworkSlot + "\\CopyPaste6.max") #select #mergeDups)	
			)
	)
on CopyPaste6 open do try (
		PastBMP6 = NetworkSlot +"\\CopyPaste6.bmp"
		Pasteselected6.images = #(PastBMP6, undefined, 1,1,1,1,1 ) 
	) catch (print"Je suis un bouton vierge !")
)
on ConfPath pressed do
	(
			--NetworkSlot = GetINISetting ((getDir #AutoBack )+"\\copytor.ini") "NetworkSlot" "NetworkSlot"
			--print (NetworkSlot +"fromgetini")
	try(closeRolloutfloater ChooseYourPath) catch()	
	rollout ChooseYourPath "Choose Your Path"
	(
			label Label_infos "Choose a Local Network Path to use Copitor"
			button SetthePath NetworkSlot pos:[5,30] width:390 height:25
			button SetBacktoDefault "Back to Default in Autoback Folder" pos:[5,60] width:390 height:25
			
		on SetthePath pressed do
		(
			NetworkSlot = getSavepath() 
			Print NetworkSlot 
			SetthePath.text = NetworkSlot
			SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste6Slot" "NetworkSlot" NetworkSlot --(selection.count as string)
			ConfPath.toolTip=(NetworkSlot as string) --Update the current path on the tooltip
			try(
				PastBMP6 = NetworkSlot+"\\CopyPaste6.bmp"
				Pasteselected6.images = #(PastBMP6, undefined, 1,1,1,1,1 ) 	
			)catch (
				Pasteselected6.images = maskImage
				print"Je suis un bouton vierge !"
				)
			destroyDialog ChooseYourPath
		)
		on SetBacktoDefault pressed do
		(
			NetworkSlot = (getdir #AutoBack) as string
			SetINISetting ((getDir #AutoBack )+"\\copytor.ini") "CopyPaste6Slot" "NetworkSlot" NetworkSlot --(selection.count as string)
			ConfPath.toolTip=(NetworkSlot as string) --Update the current path on the tooltip
			try(
				PastBMP6 = NetworkSlot+"\\CopyPaste6.bmp"
				Pasteselected6.images = #(PastBMP6, undefined, 1,1,1,1,1 ) 	
			)catch (
				Pasteselected6.images = maskImage
				print"Je suis un bouton vierge !"
				)
			destroyDialog ChooseYourPath
		)
	)
	createDialog ChooseYourPath 400 100
)
-----=====================================================================================================================

on Copitor open do try (
		PastBMP1 =(getDir #AutoBack )+"\\CopyPaste1.bmp"
		Pasteselected1.images = #(PastBMP1, undefined, 1,1,1,1,1 ) 
		PastBMP2 =(getDir #AutoBack )+"\\CopyPaste2.bmp"
		Pasteselected2.images = #(PastBMP2, undefined, 1,1,1,1,1 ) 
		PastBMP3 =(getDir #AutoBack )+"\\CopyPaste3.bmp"
		Pasteselected3.images = #(PastBMP3, undefined, 1,1,1,1,1 ) 
		PastBMP4 =(getDir #AutoBack )+"\\CopyPaste4.bmp"
		Pasteselected4.images = #(PastBMP4, undefined, 1,1,1,1,1 ) 
		PastBMP5 =(getDir #AutoBack )+"\\CopyPaste5.bmp"
		Pasteselected5.images = #(PastBMP5, undefined, 1,1,1,1,1 ) 	
		PastBMP6 = NetworkSlot+"\\CopyPaste6.bmp"
		Pasteselected6.images = #(PastBMP6, undefined, 1,1,1,1,1 ) 	
	) catch (print"Je suis un bouton vierge !")

-----=====================================================================================================================
		HyperLink hp1 "mathieujacquin.com" address:"http://www.mathieujacquin.com/" align:#center
-----=====================================================================================================================

)--rollout

	CreateDialog Copitor
	Try (setdialogpos Copitor (execute DialogPositionz)) Catch()
)--macro 